theory VSList 
imports VSPeano
begin

--{* The List type *}
typedecl 'a list

axiomatization
  Empty :: "'a list"   ("[]")
and
  Cons  :: "'a=> 'a list=> 'a list"   (infixr ":" 70)
where
  empty_const_disj: "ALL x xs. ~ ([] = x : xs)"
and
  cons_inj: "(x:xs) = (y:ys) --> x= y & xs= ys"
and
  list_induct: "[| P []; ALL x xs. P xs --> P (x:xs) |] ==> P ys"
and
  list_generated: "ALL xs. xs = [] | (EX y ys. xs= y:ys)"

--{* Example definition: append *}
axiomatization
  append :: "'a list=> 'a list=> 'a list" (infix "++" 60)
where
  app_empty: "[] ++ bs     = bs"
and
  app_cons:  "(a:as) ++ bs = a:(as++ bs)"
  
end

