header{* Very Simple Peano arithmetic *}
theory VSPeano 
imports VSPresburger
begin

text{* Peano-Arithmetik: natrliche Zahlen mit Multiplikation. *}

axiomatization
  times :: "N=> N=> N"  (infix "*" 70)
where
  times_zero_l: "Z* y  = Z"
and
  times_succ_l:" S y* x= x+ y*x"

definition
  One :: "N"
where
  "One == S Z"  --{* 1 == Succ 0 *}

section{* Eigenschaften der Eins. *}

lemma add_one_l: "One+ a= S a"
  apply (unfold One_def)
  apply (rule trans, rule plus_succ_l)
  apply (rule cong [where f="%y. S y"])
  apply (rule plus_zero_l)
  done

lemma add_one_r: "a+ One= S a"
  by (rule trans, rule plus_comm, rule add_one_l)

lemma times_one_l: "One* b= b"
  apply (unfold One_def)
  apply (rule trans, rule times_succ_l)
  apply (rule trans, rule cong [where f="%y. b+ y"], rule times_zero_l)
  apply (rule plus_zero_r)
  done

lemma times_one_r: "b* One= b"
  apply (unfold One_def)
  apply (rule induct [where y= "b"])
  apply (rule times_zero_l)
  apply (rule allI, rule impI)
  apply (rule trans, rule times_succ_l)
  apply (rule trans, rule cong [where f="%y. S Z+ y"], assumption) --{* ind. hyp. *}
  apply (fold One_def, rule add_one_l)
  done

section{* Distributivitt der Multiplikation ber Addition. *}

lemma mult_distrib: "a*(b+ c)= a*b+ a*c"
  apply (rule induct [where y="a"])
  apply (rule trans)
  apply (rule times_zero_l)
  apply (rule sym, rule trans)
  apply (rule cong [where f="%x. x+ Z*c"]) 
  apply (rule times_zero_l)
  apply (rule trans)
  apply (rule plus_zero_l)
  apply (rule times_zero_l)
  apply (rule allI, rule impI)
  apply (rule trans)
  apply (rule times_succ_l)
  apply (rule trans)
  apply (rule cong [where f="%x. (b+c)+ x"])
  apply (assumption)
  apply (rule trans)
  apply (rule sym [OF plus_assoc])
  apply (rule trans, rule cong [where f="%x. b+ x"])  
  apply (rule plus_assoc)
  apply (rule trans, rule_tac f="%y. b+ (y+ x*c)" in cong)
  apply (rule plus_comm)
  apply (rule trans, rule cong [where f="%x. b+ x"])
  apply (rule sym [OF plus_assoc])
  apply (rule trans)
  apply (rule plus_assoc)
  apply (rule trans, rule_tac f="%y. y+ (c+ x*c)" in cong)
  apply (rule sym [OF times_succ_l])
  apply (rule trans, rule_tac f="%y. S x* b+ y" in cong)
  apply (rule sym [OF times_succ_l])
  apply (rule refl)
  done --{* Phew! *}

end
