header {* Very Simple Predicate Logic *}
theory VSPred
imports VSPL
begin

typedecl i   --{* Terms *}

section {* Der Allquantor *}

axiomatization
  All  :: "('a => o)=> o"      (binder "ALL " 10)
where
  allI:   "(!!x. P x) ==> (ALL x. P x)"
and
  allE:   "ALL x. P x ==> P t"


section{* Der Existenzquantor *}

definition
  Ex :: "('a => o)=> o"      (binder "EX " 10)
where
  "Ex P == ~ (ALL x. (~ (P x)))" 

lemma exI: "P t ==> EX x. P x"
 apply (unfold Ex_def)
 apply (rule notI)
 apply (rule notE [where P="P t"])
 apply (rule allE [where t="t"])
 apply (assumption)
 apply (assumption)
 done

lemma exE: "[| EX x. P x; !! x. P x ==> Q |] ==> Q"
 apply (unfold Ex_def)
 apply (rule Raa')
 apply (erule notE [where P="ALL x. ~ P x"]) 
 apply (rule allI)
 apply (rule notI)
 apply (rule notE [where P="Q"])
 apply (assumption)
 apply (assumption)
 done

end
